#include "../include/NumberHelper.h"
#include <iostream>
#include <string>
#include <sstream>
#include <vector>

vector<int> NumberHelper::getRolls(string csv){
    vector<int> rolls;
    stringstream ss(csv);
    string number;
    
    // Get number from the CSV file, split by comma, and convert to int.
    while (getline(ss, number, ',')) {
        rolls.push_back(stoi(number));
    }
    
    return rolls;
}

bool NumberHelper::validateRolls(vector<int> rolls){
    int rollCount = rolls.size();
    
    for(int i = 0; i < rollCount; ++i) {
        if(rolls[i] > 10 || rolls[i] < 0) {
            cerr << "Number: " << rolls[i] << " is invalid.";
            return false;
        }
    }
    
    // A game can not have less than 12 rolls, and more than 21.
    if (rollCount < 12 || rollCount > 21) {
        cerr << "Incorrect amount of rolls.";
        return false;
    }
    
    // 10th frame rule.
    if (rollCount == 21) {
        if (rolls[18] != 10 && rolls[18] + rolls[19] != 10) {
            return false;
        }
    }
    
    return true;
}